---
title: RelativeOrientationSensor
slug: Web/API/RelativeOrientationSensor
tags:
  - API
  - Generic Sensor API
  - Interface
  - Orientation Sensor API
  - OrientationSensor
  - Reference
  - RelativeOrientationSensor
  - Sensor
  - Sensor APIs
  - Sensors
---
<div>{{APIRef("Generic Sensor API")}}</div>

<p><span class="seoSummary">The <strong><code>RelativeOrientationSensor</code></strong> interface of the <a href="/docs/Web/API/Sensor_APIs">Sensor APIs</a> describes the device's physical orientation without regard to the Earth's reference coordinate system. </span></p>

<p>To use this sensor, the user must grant permission to the <code>'accelerometer'</code>, and <code>'gyroscope'</code> device sensors through the {{domxref('Permissions')}} API.</p>

<p>If a feature policy blocks use of a feature it is because your code is inconsistent with the policies set on your server. This is not something that would ever be shown to a user. See {{httpheader('Feature-Policy')}} for implementation instructions.</p>

<h2 id="Constructor">Constructor</h2>

<dl>
 <dt>{{domxref("RelativeOrientationSensor.RelativeOrientationSensor()")}}</dt>
 <dd>Creates a new <code>RelativeOrientationSensor</code> object.</dd>
</dl>

<h2 id="Properties">Properties</h2>

<p><em>No specific properties; inherits methods from its ancestors {{domxref('OrientationSensor')}} and {{domxref('Sensor')}}.</em></p>

<h3 id="Event_handlers">Event handlers</h3>

<p><em>No specific event handlers; inherits methods from its ancestor, {{domxref('Sensor')}}.</em></p>

<h2 id="Methods">Methods</h2>

<p><em>No specific methods; inherits methods from its ancestors {{domxref('OrientationSensor')}} and {{domxref('Sensor')}}.</em></p>

<h2 id="Examples">Examples</h2>

<h3 id="Basic_Example">Basic Example</h3>

<p>The following example, which is loosely based on <a href="https://intel.github.io/generic-sensor-demos/orientation-phone/">Intel's Orientation Phone demo</a>,  instantiates an <code>RelativeOrientationSensor</code> with a frequency of 60 times a second.</p>

<div class="notecard note">
<p>Note that the Intel demo this is based on uses the <code>AbsoluteOreintationSensor</code>. On each reading it uses {{domxref('OrientationSensor.quaternion')}} to rotate a visual model of a phone.</p>
</div>

<pre class="brush: js">const options = { frequency: 60, referenceFrame: 'device' };
const sensor = new RelativeOrientationSensor(options);

sensor.addEventListener('reading', () =&gt; {
  // model is a Three.js object instantiated elsewhere.
  model.quaternion.fromArray(sensor.quaternion).inverse();
});
sensor.addEventListener('error', error =&gt; {
  if (event.error.name == 'NotReadableError') {
    console.log("Sensor is not available.");
  }
});
sensor.start();</pre>

<h3 id="Permissions_Example">Permissions Example</h3>

<p>Using orientation sensors requires requsting permissions for multiple device sensors. Becuase the {{domxref('Permissions')}} uses promises, a good way to request permissions is to use {{jsxref('Promise.all')}}.</p>

<pre class="brush: js">const sensor = new RelativeOrientationSensor();
Promise.all([navigator.permissions.query({ name: "accelerometer" }),
             navigator.permissions.query({ name: "gyroscope" })])
       .then(results =&gt; {
         if (results.every(result =&gt; result.state === "granted")) {
           sensor.start();
           ...
         } else {
           console.log("No permissions to use RelativeOrientationSensor.");
         }
   });</pre>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <tbody>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
  <tr>
   <td>{{SpecName('Orientation Sensor','#relativeorientationsensor-interface','RelativeOrientationSensor')}}</td>
   <td>{{Spec2('Orientation Sensor')}}</td>
   <td>Initial definition.</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("api.RelativeOrientationSensor")}}</p>
